lexer grammar BoppiCoreTokens;

DELIM: ';';
HASTYPE: ':';
LAMBDA: '\u03BB';
PI: '\u03A0';
PAROPEN: '(';
PARCLOSE: ')';
DATA: 'data';
LET: 'let';
IN: 'in';
CASE: 'case';
TO: '\u2192';
EQUALS: '=';
BLOCKOPEN: '{';
BLOCKCLOSE: '}';
LITERALINT: '0' | [1-9][0-9]*;
LITERALCHAR: '\'' . '\'';

IDENTIFIER: [\p{Alphabetic}]+ | '_' | '\u2605';

WHITESPACE: [\p{White_Space}] -> skip;
BLOCKCOMMENT: '/*' .*? '*/' -> skip;
